Attribute VB_Name = "modMain"
Option Explicit
Option Base 1
Option Compare Text
DefLng A-Z

Public Const ERROR_MORE_DATA           As Long = 234&
Public Const ERROR_SUCCESS             As Long = 0&

Public Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (pTo As Any, uFrom As Any, ByVal lSize As Long)
Public Declare Function StrLenW Lib "kernel32" Alias "lstrlenW" (ByVal Ptr As Long) As Long
Public Declare Function NetAPIBufferFree Lib "Netapi32.dll" Alias "NetApiBufferFree" (ByVal Ptr As Long) As Long

Public Function PointerToUnicodeStr(ByVal xi_lngPtrToString As Long) As String
On Error Resume Next                   ' Don't accept an error here
   Dim p_abytBuffer()                  As Byte
   Dim p_lngLen                        As Long
   Dim p_strTmp                        As String
   Dim p_lngRtn                        As Long
   
   ' ------------------------------------------
   ' Get the length of the string from the pointer
   ' ------------------------------------------
   p_lngLen = StrLenW(xi_lngPtrToString) * 2
   
   ' ------------------------------------------
   ' Now convert to a string
   ' ------------------------------------------
   If xi_lngPtrToString <> 0 Then
      ReDim p_abytBuffer(0 To (p_lngLen - 1)) As Byte
      CopyMem p_abytBuffer(0), ByVal xi_lngPtrToString, p_lngLen
      p_strTmp = p_abytBuffer
   End If
   
   ' ------------------------------------------
   ' Set the return value
   ' ------------------------------------------
   PointerToUnicodeStr = p_strTmp
   
End Function
