VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmQuotaEntries 
   Caption         =   "Quota Entries for ..."
   ClientHeight    =   5925
   ClientLeft      =   540
   ClientTop       =   2925
   ClientWidth     =   10050
   LinkTopic       =   "Form1"
   ScaleHeight     =   5925
   ScaleWidth      =   10050
   Begin VB.ComboBox cboLookIn 
      Height          =   315
      Left            =   3300
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   30
      Width           =   6675
   End
   Begin MSComctlLib.ListView lstvwQuotaEntries 
      Height          =   5505
      Left            =   30
      TabIndex        =   0
      Top             =   390
      Width           =   9975
      _ExtentX        =   17595
      _ExtentY        =   9710
      View            =   3
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      SmallIcons      =   "ImageList1"
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.Image imgRefresh 
      Height          =   240
      Left            =   420
      Picture         =   "QuotaEntries.frx":0000
      Top             =   90
      Width           =   240
   End
   Begin VB.Image imgClose 
      Height          =   240
      Left            =   720
      Picture         =   "QuotaEntries.frx":0342
      Top             =   90
      Width           =   240
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      Caption         =   "&Look in:"
      Height          =   195
      Index           =   0
      Left            =   2640
      TabIndex        =   2
      Top             =   90
      Width           =   570
   End
   Begin VB.Image imgProperties 
      Height          =   240
      Left            =   90
      Picture         =   "QuotaEntries.frx":0684
      Top             =   90
      Width           =   240
   End
End
Attribute VB_Name = "frmQuotaEntries"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Base 1
Option Compare Text
DefLng A-Z

Private m_strCurrDomainName            As String
Private m_strCurrComputerName          As String
Private m_strDrive                     As String
Private m_strFullDriveName             As String
Private m_strDSNDriveName              As String
Private m_lngStartIndex                As Long
Private m_colUsers                     As colUsers
Private m_strChangedUser               As String

Private Sub AddDomainsToCombo()
   Dim p_objNTSysInfo                  As ActiveDs.WinNTSystemInfo
   Dim p_objADsContainer               As IADsContainer
   Dim p_objADsChild                   As IADs
   
   ' ------------------------------------------
   ' Get the info on current computer
   ' ------------------------------------------
   Set p_objNTSysInfo = New ActiveDs.WinNTSystemInfo
   m_strCurrComputerName = p_objNTSysInfo.ComputerName
   m_strCurrDomainName = p_objNTSysInfo.DomainName

   ' ------------------------------------------
   ' Add current computer (and possibly domain)
   '     to combo box
   ' ------------------------------------------
   Me.cboLookIn.AddItem m_strCurrComputerName
   If Trim$(m_strCurrDomainName) <> "" And _
      UCase$(Trim$(m_strCurrDomainName)) <> UCase$(Trim$(m_strCurrComputerName)) Then
      Me.cboLookIn.AddItem m_strCurrDomainName
      m_lngStartIndex = 1
   Else
      m_strCurrDomainName = m_strCurrComputerName
      m_lngStartIndex = 0
   End If
   
   ' ------------------------------------------
   ' Get the other domain(s), if present
   ' ------------------------------------------
   Set p_objADsContainer = GetObject("WinNT:")
   For Each p_objADsChild In p_objADsContainer
      If UCase$(p_objADsChild.Class) = "DOMAIN" Then
         If p_objADsChild.Name <> m_strCurrDomainName Then
            Me.cboLookIn.AddItem p_objADsChild.Name
         End If
      End If
   Next p_objADsChild

End Sub

Public Sub Init(ByVal Drive As String, _
                ByVal FullDriveName As String)
   Dim p_objNTSysInfo                  As ActiveDs.WinNTSystemInfo
   Dim p_objIADsComputer               As ActiveDs.IADsComputer
   Dim p_objDomain                     As ActiveDs.IADs
   Dim p_strDomainName                 As String
   Dim p_strLocalComputer              As String
   Dim p_strDNLocalComputer            As String
   Dim p_strTmp                        As String
   
   ' ------------------------------------------
   ' Set the passed vars into module vars
   ' ------------------------------------------
   m_strDrive = Drive
   m_strFullDriveName = UCase$(FullDriveName)
   
   ' ------------------------------------------
   ' Get the info on current computer
   ' ------------------------------------------
   Set p_objNTSysInfo = New ActiveDs.WinNTSystemInfo
   p_strDomainName = Trim$(p_objNTSysInfo.DomainName)
   p_strLocalComputer = Trim$(p_objNTSysInfo.ComputerName)
   Set p_objIADsComputer = GetObject("WinNT://" & p_strLocalComputer & ",Computer")
   m_strDSNDriveName = p_objIADsComputer.ADsPath
   
End Sub

Public Sub UpdateUsers()
   SetUsers xi_strDomainName:=Me.cboLookIn.Text
End Sub

Private Sub SetupListview()
   Dim p_objColHeader                  As ColumnHeader

   Me.lstvwQuotaEntries.ListItems.Clear
   Me.lstvwQuotaEntries.ColumnHeaders.Clear
   Set p_objColHeader = Me.lstvwQuotaEntries.ColumnHeaders.Add(Text:="In Folder", _
                              Width:=Me.lstvwQuotaEntries.Width * 0.15)
   Set p_objColHeader = Me.lstvwQuotaEntries.ColumnHeaders.Add(Text:="Status", _
                              Width:=Me.lstvwQuotaEntries.Width * 0.09)
   Set p_objColHeader = Me.lstvwQuotaEntries.ColumnHeaders.Add(Text:="Name", _
                              Width:=Me.lstvwQuotaEntries.Width * 0.17)
   Set p_objColHeader = Me.lstvwQuotaEntries.ColumnHeaders.Add(Text:="Logon Name", _
                              Width:=Me.lstvwQuotaEntries.Width * 0.2)
   Set p_objColHeader = Me.lstvwQuotaEntries.ColumnHeaders.Add(Text:="Amount Used", _
                              Width:=Me.lstvwQuotaEntries.Width * 0.11)
   Set p_objColHeader = Me.lstvwQuotaEntries.ColumnHeaders.Add(Text:="Quota Limit", _
                              Width:=Me.lstvwQuotaEntries.Width * 0.11)
   Set p_objColHeader = Me.lstvwQuotaEntries.ColumnHeaders.Add(Text:="Warning Level", _
                              Width:=Me.lstvwQuotaEntries.Width * 0.1)
   Set p_objColHeader = Me.lstvwQuotaEntries.ColumnHeaders.Add(Text:="Percent Used", _
                              Width:=Me.lstvwQuotaEntries.Width * 0.1)
   
End Sub

Private Sub cboLookIn_Click()
   Dim p_strSelection                  As String
   
   p_strSelection = Me.cboLookIn.Text
   
   
   SetUsers p_strSelection
   
End Sub

Private Sub SetUsers(ByVal xi_strDomainName As String)
   Dim p_objColHeader                  As ColumnHeader
   Dim p_objNewListItem                As ListItem
   Dim p_objUser                       As clsUsers
   Dim p_enumStatus                    As enmStatusEnum
   Dim p_blnRebuilding                 As Boolean
   
   Me.MousePointer = vbHourglass
   Me.lstvwQuotaEntries.ListItems.Clear
   Me.lstvwQuotaEntries.ColumnHeaders.Clear
   Set p_objColHeader = Me.lstvwQuotaEntries.ColumnHeaders.Add(Text:="Working", Width:=Me.lstvwQuotaEntries.Width)
   Me.lstvwQuotaEntries.ListItems.Add Text:="     Retrieving information -- Please wait..."
   Me.lstvwQuotaEntries.Refresh
   Me.Refresh
   DoEvents
   
   Me.MousePointer = vbHourglass
   Set m_colUsers = Nothing
   Set m_colUsers = New colUsers
   m_colUsers.Init DomainName:=xi_strDomainName, _
                   DriveName:=m_strDrive, _
                   DNSName:=m_strDSNDriveName
   
   Me.MousePointer = vbHourglass
   SetupListview
   
   p_blnRebuilding = m_colUsers.IsRebuilding
   
   Me.MousePointer = vbHourglass
   If m_colUsers.Count > 0 Then
      For Each p_objUser In m_colUsers
         p_enumStatus = p_objUser.StatusEnum
         Select Case p_enumStatus
            Case dqAcctResolved, _
                 dqAcctUnknown, _
                 dqAcctUnresolved, _
                 dqAcctDeleted, _
                 dqAcctUnavailable
               Set p_objNewListItem = Me.lstvwQuotaEntries.ListItems.Add(Text:=xi_strDomainName)
               If Trim$(UCase$(p_objUser.LogonName)) = m_strChangedUser And _
                  p_blnRebuilding = True Then
                  p_objNewListItem.SubItems(1) = "Rebuilding..."
                  p_objNewListItem.SubItems(4) = "0"
                  p_objNewListItem.SubItems(5) = "0"
                  p_objNewListItem.SubItems(6) = "0"
                  p_objNewListItem.SubItems(7) = "0"
               Else
                  p_objNewListItem.SubItems(1) = p_objUser.Status
                  p_objNewListItem.SubItems(4) = p_objUser.AmountUsed
                  p_objNewListItem.SubItems(5) = p_objUser.QuotaLimit
                  p_objNewListItem.SubItems(6) = p_objUser.WarningLevel
                  p_objNewListItem.SubItems(7) = p_objUser.PercentUsed
               End If
               
               p_objNewListItem.SubItems(2) = p_objUser.Name
               p_objNewListItem.SubItems(3) = p_objUser.LogonName
               p_objNewListItem.Tag = p_objUser.Index
            Case dqAcctInvalid
               Debug.Print
         End Select
      Next p_objUser
   End If
   
   Me.lstvwQuotaEntries.Sorted = True
   Me.lstvwQuotaEntries.SortKey = 1
   Me.lstvwQuotaEntries.SortOrder = lvwAscending

   Me.MousePointer = vbNormal

End Sub

Private Sub Form_Load()
   
   Me.Caption = "Quota Entries for " & m_strFullDriveName
   
   AddDomainsToCombo
   
   SetUsers xi_strDomainName:=m_strCurrDomainName
   
   If Me.cboLookIn.ListCount > 0 Then
      Me.cboLookIn.ListIndex = m_lngStartIndex
   End If
   
End Sub

Private Sub Form_Resize()
   Dim p_objColHeaders                 As ColumnHeaders
   
   Me.lstvwQuotaEntries.Move 60, _
                             390, _
                             Me.Width - 210, _
                             Me.Height - 850
   
   Set p_objColHeaders = Me.lstvwQuotaEntries.ColumnHeaders
   
   p_objColHeaders(1).Width = Me.lstvwQuotaEntries.Width * 0.13
   p_objColHeaders(2).Width = Me.lstvwQuotaEntries.Width * 0.11
   p_objColHeaders(3).Width = Me.lstvwQuotaEntries.Width * 0.15
   p_objColHeaders(4).Width = Me.lstvwQuotaEntries.Width * 0.19
   p_objColHeaders(5).Width = Me.lstvwQuotaEntries.Width * 0.11
   p_objColHeaders(6).Width = Me.lstvwQuotaEntries.Width * 0.11
   p_objColHeaders(7).Width = Me.lstvwQuotaEntries.Width * 0.1
   p_objColHeaders(8).Width = Me.lstvwQuotaEntries.Width * 0.1

End Sub

Private Sub imgClose_Click()
   Unload Me
End Sub

Private Sub imgProperties_Click()
   Dim p_objUser                       As clsUsers
   Dim p_strKey                        As String
      
   p_strKey = Trim$(Me.lstvwQuotaEntries.SelectedItem.Tag)
   If p_strKey = "" Then
      Exit Sub
   End If
   
   Set p_objUser = m_colUsers.Item(p_strKey)
   m_strChangedUser = p_objUser.LogonName
   Set frmQuotaUserSettings.UserInfo = p_objUser
   frmQuotaUserSettings.Drive = m_strDrive
   frmQuotaUserSettings.Show vbModeless
End Sub

Private Sub imgRefresh_Click()
   UpdateUsers
End Sub

Private Sub lstvwQuotaEntries_DblClick()
   imgProperties_Click
End Sub
