VERSION 5.00
Begin VB.Form frmQuotaUserSettings 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Quota Settings for ..."
   ClientHeight    =   3510
   ClientLeft      =   510
   ClientTop       =   2040
   ClientWidth     =   5640
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3510
   ScaleWidth      =   5640
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   4410
      TabIndex        =   14
      Top             =   3030
      Width           =   1155
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   3150
      TabIndex        =   13
      Top             =   3030
      Width           =   1155
   End
   Begin VB.TextBox txtWarningLevel 
      Alignment       =   1  'Right Justify
      Height          =   315
      Left            =   2130
      TabIndex        =   9
      Top             =   2490
      Width           =   1365
   End
   Begin VB.TextBox txtLimitDiskSpace 
      Alignment       =   1  'Right Justify
      Height          =   315
      Left            =   2130
      TabIndex        =   8
      Top             =   2100
      Width           =   1365
   End
   Begin VB.OptionButton optDiskUsage 
      Caption         =   "&Limit disk space to"
      Height          =   225
      Index           =   1
      Left            =   270
      TabIndex        =   7
      Top             =   2130
      Width           =   1635
   End
   Begin VB.OptionButton optDiskUsage 
      Caption         =   "D&o not limit disk usage"
      Height          =   225
      Index           =   0
      Left            =   270
      TabIndex        =   6
      Top             =   1740
      Value           =   -1  'True
      Width           =   1995
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      Caption         =   "MB"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Index           =   5
      Left            =   3600
      TabIndex        =   12
      Top             =   2550
      Width           =   285
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      Caption         =   "MB"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Index           =   4
      Left            =   3600
      TabIndex        =   11
      Top             =   2160
      Width           =   285
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      Caption         =   "Set warning level to"
      Height          =   195
      Index           =   3
      Left            =   450
      TabIndex        =   10
      Top             =   2550
      Width           =   1395
   End
   Begin VB.Label lblQuotaRemaining 
      Height          =   195
      Left            =   1500
      TabIndex        =   5
      Top             =   1170
      Width           =   4245
   End
   Begin VB.Label lblQuotaUsed 
      Height          =   195
      Left            =   1500
      TabIndex        =   4
      Top             =   840
      Width           =   4245
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      Caption         =   "Quota Remaining:"
      Height          =   195
      Index           =   2
      Left            =   105
      TabIndex        =   3
      Top             =   1170
      Width           =   1275
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      Caption         =   "Quota Used:"
      Height          =   195
      Index           =   1
      Left            =   480
      TabIndex        =   2
      Top             =   840
      Width           =   900
   End
   Begin VB.Label lblUser 
      BorderStyle     =   1  'Fixed Single
      Height          =   285
      Left            =   690
      TabIndex        =   1
      Top             =   240
      Width           =   4875
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      Caption         =   "User:"
      Height          =   195
      Index           =   0
      Left            =   210
      TabIndex        =   0
      Top             =   270
      Width           =   375
   End
End
Attribute VB_Name = "frmQuotaUserSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Base 1
Option Compare Text
DefLng A-Z

Private m_objUserInfo                  As clsUsers
Private m_strDrive                     As String
Private m_strDSNDrive                  As String

Public Property Set UserInfo(ByVal UserObj As clsUsers)
   Set m_objUserInfo = UserObj
End Property

Public Property Let DSNDrive(ByVal Drive As String)
   DSNDrive = m_strDSNDrive
End Property

Public Property Let Drive(ByVal Drive As String)
   m_strDrive = Drive
End Property

Private Sub cmdCancel_Click()
   Unload Me
End Sub

Private Sub cmdOK_Click()
   Dim p_objModifyUser                 As clsModifyUser
   
   If Me.optDiskUsage(0).Value = True Then
      ' Don't limit usage
      m_objUserInfo.WarningLevel = 0
      m_objUserInfo.QuotaLimit = 0
   Else
      If CLng(Me.txtLimitDiskSpace.Text) <= 0 Then
         MsgBox "Must have a positive value for 'Limit disk space to' if you want to limit disk space!"
         Exit Sub
      End If
      
      If CLng(Me.txtLimitDiskSpace.Text) < CLng(Me.txtWarningLevel.Text) Then
         MsgBox "Warning level cannot be greater than your disk space limit!"
         Me.txtWarningLevel.Text = Me.txtLimitDiskSpace.Text
         Exit Sub
      End If
      
      m_objUserInfo.WarningLevel = CLng(Me.txtWarningLevel.Text)
      m_objUserInfo.QuotaLimit = CLng(Me.txtLimitDiskSpace.Text)
   End If
   
   Me.Visible = False
   
   Set p_objModifyUser = New clsModifyUser
   
   p_objModifyUser.ModUser DriveName:=m_strDrive, _
                           DSNDriveName:=m_strDSNDrive, _
                           UserInfo:=m_objUserInfo
   
   Set p_objModifyUser = Nothing
   
   ' Update with your changes
   frmQuotaEntries.UpdateUsers
   
   Unload Me
   
End Sub

Private Sub SetDisabled(ByVal IsEnabled As Boolean)
   
   Me.lblCaption(1).Enabled = IsEnabled
   Me.lblCaption(2).Enabled = IsEnabled
   Me.lblCaption(3).Enabled = IsEnabled
   Me.lblCaption(4).Enabled = IsEnabled
   Me.lblCaption(5).Enabled = IsEnabled
   
   Me.lblQuotaRemaining.Enabled = IsEnabled
   Me.lblQuotaUsed.Enabled = IsEnabled
   
   Me.txtLimitDiskSpace.Enabled = IsEnabled
   Me.txtWarningLevel.Enabled = IsEnabled
   
End Sub

Private Sub Form_Load()
   Dim p_lngAmountUsed                 As Long
   Dim p_lngAmountUsedBytes            As Long
   Dim p_sngPercentUsed                As Long
   Dim p_lngAmountLeft                 As Long
   
   Me.Caption = "Quota Settings for " & m_objUserInfo.Name
   Me.lblUser = m_objUserInfo.Name & " (" & m_objUserInfo.DomainName & "\" & m_objUserInfo.Name & ")"
   
   If m_objUserInfo.QuotaLimit > 0 Then
      Me.optDiskUsage(1).Value = True
      
      p_lngAmountUsed = m_objUserInfo.AmountUsed
      p_lngAmountUsedBytes = p_lngAmountUsed * 1024& * 1024&
      p_sngPercentUsed = m_objUserInfo.PercentUsed
      p_lngAmountLeft = m_objUserInfo.QuotaLimit - m_objUserInfo.AmountUsed
      If p_lngAmountLeft <= 0 Then
         p_lngAmountLeft = 0
      End If
      
      Me.lblQuotaUsed.Caption = CStr(p_lngAmountUsedBytes) & " bytes (" & _
                                CStr(p_sngPercentUsed) & "%)"
      Me.lblQuotaRemaining.Caption = CStr(p_lngAmountLeft) & "MB"
      
      Me.txtLimitDiskSpace.Text = m_objUserInfo.QuotaLimit
      Me.txtWarningLevel.Text = m_objUserInfo.WarningLevel
      SetDisabled IsEnabled:=True
   Else
      Me.lblQuotaUsed.Caption = "0 bytes (0%)"
      Me.lblQuotaRemaining.Caption = "0 MB"
      
      Me.txtLimitDiskSpace.Text = "0"
      Me.txtWarningLevel.Text = "0"
      
      Me.optDiskUsage(0).Value = True
      SetDisabled IsEnabled:=False
   End If
   
End Sub

Private Sub optDiskUsage_Click(Index As Integer)
   
   If Index = 0 Then
      SetDisabled IsEnabled:=False
   Else
      SetDisabled IsEnabled:=True
   End If
   
End Sub
